/*

 this code is copyright 1996 by Dan Creagan.                 
 You can get him at dcreagan@scholars.bellevue.edu          


As of  the 28 July version, this skeleton requires a CGI script file on
the host to process scores.  The script is manipulated in the
writescore method (the last one).  Study it to see how to change it
for your machine.  The web version has this method disabled, but you
can enable it by uncommenting the procedure call at line 739.

The script should look like this in GNU C for Linux
with CGI runnable anywhere:


#include <stdio.h>
#include <stdlib.h>
#include <string.h>


void main(int argc, char *argv[])
{

FILE *outfile;
char score[120];
char maxques[120];
char caption[120];
char filename[120];
int x,y;

if (argc<2)
  {
    printf("\nContent-type: text/plain \n\n");
    printf("Invalid number of arguments.(%d)\n",argc);
    exit(0);
   }

  strcpy(filename,"javascores.dat");
  strcpy(score,argv[1]);
  if (argc>2){strcpy(maxques,argv[2]);}
  if (argc>3){strcpy(caption,argv[3]);}
  outfile=fopen(filename,"at");
  if(!outfile)
  {
    printf("\nContent-type: text/plain \n\nCould not open the scorefile.\n");
    exit(0);
  }

  fprintf(outfile,"     %s ",score);
  if (argc>2) fprintf(outfile,"                 %s ",maxques);
  if (argc>3) fprintf(outfile,"           %s",caption);
  fprintf(outfile,"\n");  
  fclose(outfile);
  printf("Content-type: text/plain \n\n");
  printf("\nScore File Updated: score = %s\n",argv[1]);
}  
*/

import java.net.*;
import java.sql.*;
import java.applet.*;
import java.awt.*;
import java.util.Date;
import java.util.Random;
import java.io.*;

//
//  The following class declaration gets modified by the javconvt.pl
//  program.  It gets updated to the name of the .txt file you feed
//  it.  The text file has the questions for the students/viewers.
//

public class di532 extends Applet{

     String msg3 = new String("by Dan Creagan, ver 72896");
                                                               
     Image img;
     Image jbutt1;
     Image logo1;

     Random rnd1 = new Random();
     int dummy[] = new int[2000];
     int deal[] = new int[2000];
     int cons=-1;

     int maxques = 72;
     double maxquestions = 72.0;
     int maxques2;
     int maxques3 = 0;

     String questions[] = new String[2000];
     String answer = new String(" ");
     String imagestring=new String("nwadmin.gif");
     String jbutt = new String("jbutt.gif");
     String logo = new String("bs4.gif");
     String caption = new String("JAVATEST");
     String CGIcaption = new String("JAVATEST");

     int debugx = 0;
     int debugy = 0;
     int score=0;
     int currentquestion = 1;
     int retries = 0;
     int totalquestions = 0;
     int maxretries =1;
     AudioClip beep;
     AudioClip hasta;
     AudioClip gong;
     AudioClip hello;
     AudioClip bkgrd;
     String title="JAVA Quiz Shell";
     boolean soundtoggle = true;
     boolean retry = false;
     boolean qbutt = false;
     boolean chk1 = false;
     boolean chk2 = false;
     boolean chk3 = false;
     boolean chk4 = false;
     boolean chk5 = false;
     boolean enter = false;
     boolean restart = false;
     boolean paintimg = false;
     boolean imagestringavail = false;
     boolean paintmsg = false;
     boolean re = false;
     boolean debug=false;
     boolean endtest=false;
     boolean intro=true;
     boolean resetclicked=false;
     boolean chkboxclicked=false;

     String line1 = new String(" ");
     String line2 = new String(" ");
     String line3 = new String(" ");
     String line4 = new String(" ");

     String q1 = new String(" ");
     String q2 = new String(" ");
     String q3 = new String(" ");
     String q4 = new String(" ");
     String q5 = new String(" ");

     String msg;
     String msg2= new String("NoSound");

     int xx=1;
     Font tr12 = new Font("TimesRoman", Font.PLAIN, 12);
     Font tr12b = new Font("TimesRoman", Font.BOLD, 12);
     Font tr14 = new Font("TimesRoman", Font.PLAIN, 14);
     Font tr14b = new Font("TimesRoman", Font.BOLD, 14);
     Font tr10 = new Font("TimesRoman", Font.PLAIN, 10);
     Font tr10b = new Font("TimesRoman", Font.BOLD, 10);
     Font tr24b = new Font("TimesRoman", Font.BOLD, 24);
     Font tr18b = new Font("TimesRoman", Font.BOLD, 18);
     Font tr36b = new Font("TimesRoman", Font.BOLD, 36);

  public void stop()
   {
    if (soundtoggle) hasta.play();
   }

  public void init()
   {

     caption=getParameter("caption");
     CGIcaption=caption;

     hello= getAudioClip(getCodeBase(),"hello2.au");
     beep = getAudioClip(getCodeBase(),"beep.au");
     hasta = getAudioClip(getCodeBase(),"hasta.au");
     gong = getAudioClip(getCodeBase(),"gong.au");
     beep.play();
     jbutt1=getImage(getCodeBase(),jbutt);

     logo1=getImage(getCodeBase(),logo);

     setup(maxques); // set up random number generator

     setBackground(Color.white);
     setuptext();
     setquestions();
     maxques2=maxques;
   }



  public void paint(Graphics g)
    {
      update(g);
    }
  public void update(Graphics g)
    {
     if (intro)
      {
       if(resetclicked)
         {
           g.setColor(Color.white);
           g.fillRect(0,0,500,400); // clear work area
           resetclicked=false;
         }
       settitle(g);
       intropaint(g);
       return;
      }
     // cls

     if(!chkboxclicked)
     {
       g.setColor(Color.white);
       g.fillRect(0,0,500,300);
     }
     if (paintimg)
       {

         img=getImage(getCodeBase(),imagestring);
         g.drawImage(img,1,1,this);
         g.setColor(Color.lightGray);
         g.setFont(tr10);
         g.fill3DRect(180,270,60,20,true);
         g.setColor(Color.black);
         g.drawString("Return",195,299);
         return;
       }

     if(paintmsg)
       {
         g.setColor(Color.red);
         g.setFont(tr24b);
         if (msg.length() > 28) g.setFont(tr14b);
         g.drawString(msg,150,150);
         g.setColor(Color.lightGray);
         g.setFont(tr10);
         g.fill3DRect(180,270,60,20,true);
         g.setColor(Color.black);
         g.drawString("Enter",199,299);
         return;
        }

     // title and credits
     settitle(g);
     // score
     writescore(g);
     // chkboxes
     writechkbox(g);
    
    }

  public void writechkbox(Graphics g)
    {
     g.setColor(Color.black);
     g.setFont(tr14);
     g.drawString(line1,50,50);
     g.drawString(line2,50,70);
     g.drawString(line3,50,90);
     g.drawString(line4,50,110);

     g.setFont(tr12b);

     g.drawString(q1,75,115);
     g.drawString(q2,75,145);
     g.drawString(q3,75,175);
     g.drawString(q4,75,205);
     g.drawString(q5,75,235);

     g.setColor(Color.lightGray);

     g.drawString(" " + Integer.toString(currentquestion) + " of " +  Double.toString(maxquestions),350,290); 

     if (imagestringavail)
       {
        g.setColor(Color.lightGray);
        g.fill3DRect(400,30,20,20,true);
        g.setColor(Color.black);
        g.setFont(tr10b);
        g.drawString("GraFik",395,60);
        g.setColor(Color.lightGray);
       }

     if((chk1)&&(totalquestions>0))
       {
         g.draw3DRect(50,100,20,20,true);
         g.setColor(Color.red);
         g.drawString("X",56,115);
         g.setColor(Color.lightGray);
       }
       else
         {
           if ((!endtest)&&(totalquestions>0)) g.fill3DRect(50,100,20,20,true);
         }
     if((chk2) && (totalquestions>1))
       {
         g.draw3DRect(50,130,20,20,true);
         g.setColor(Color.red);
         g.drawString("X",56,145);
         g.setColor(Color.lightGray);
       }
       else
         {
           if ((!endtest)&&(totalquestions>1)) g.fill3DRect(50,130,20,20,true);
         }
     if((chk3) && (totalquestions>2))
       {
         g.draw3DRect(50,160,20,20,true);
         g.setColor(Color.red);
         g.drawString("X",56,175);
         g.setColor(Color.lightGray);
       }
       else
         {
           if ((!endtest)&&(totalquestions>2)) g.fill3DRect(50,160,20,20,true);
         }
     if((chk4)&& (totalquestions>3))
       {
         g.draw3DRect(50,190,20,20,true);
         g.setColor(Color.red);
         g.drawString("X",56,205);
         g.setColor(Color.lightGray);
       }
       else
         {
           if((!endtest)&&(totalquestions>3)) g.fill3DRect(50,190,20,20,true);
         }
     if((chk5) && (totalquestions>4))
       {
         g.draw3DRect(50,220,20,20,true);
         g.setColor(Color.red);
         g.drawString("X",56,235);
         g.setColor(Color.lightGray);
       }
       else
         {
           if ((!endtest)&&(totalquestions>4)) g.fill3DRect(50,220,20,20,true);
         }
      if(enter)
       {
           g.draw3DRect(180,270,60,20,true);
       }
       else
         { 
           g.fill3DRect(180,270,60,20,true);
         }
       if(restart)
        {
          g.draw3DRect(280,270,20,20,true);
        }
        else
          {
            g.fill3DRect(280,270,20,20,true);
          }

     /*
     if (qbutt)
       {
         g.draw3DRect(280,270,20,20,true);
       }
     else
       {
         g.fill3DRect(280,270,20,20,true);
       }
     */
     // skip button

     g.fill3DRect(10,270,20,20,true);

     // sound toggle

     g.fill3DRect(40,270,20,20,true);


     g.setFont(tr10b);
     g.setColor(Color.black);
     g.drawString("Enter",199,299);
     g.drawString("Restart",276,299);
     g.drawString("Skip",10,299);
     g.drawString(msg2,34,299);


    }

     public boolean chkanswer()
       {

       //
       // called if a user has clicked enter and we now have to
       // determine if the answer given was correct.  We first
       // check to see if a box was checked and it wasn't in the answer list

        if ((chk1) && (answer.indexOf('1')<0))
          {
           return false;
          }
        if ((chk2) && (answer.indexOf('2')<0))
          {
           return false;
          }
        if ((chk3) && (answer.indexOf('3')<0))
          {
            return false;
          }
        if ((chk4) && (answer.indexOf('4')<0))
          {
            return false;
          }
        if ((chk5) && (answer.indexOf('5')<0))
          {
            return false;
          }
        // check to see if a box WASN'T checked and it WAS in answer list

        if ((!chk1) && (answer.indexOf('1')>-1))
          {
            return false;
          }
        if ((!chk2) && (answer.indexOf('2')>-1))
          {
            return false;
          }
        if ((!chk3) && (answer.indexOf('3')>-1))
          {
            return false;
          }
        if ((!chk4) && (answer.indexOf('4')>-1))
          {
            return false;
          }
        if ((!chk5) && (answer.indexOf('5')>-1))
          {
            return false;
          }
        return true;
       }



  public boolean mouseUp(Event evt, int x, int y)
    {
      chkboxclicked=false;
      //
      // variable 'intro' is true when the first screen is showing
      // if true, we look for mouse clicks that signify change of
      // total questions that user wants to see
      //

      if((intro)&& (x>285) && (x<329) && (y>174) && (y<202)) // + clicked
        {
         if ((maxques+1)>maxques2) return true;
         maxques++;
         maxquestions++;
         repaint();
         return(true);
        }
      if ((intro) && (x>285) && (x<329) && (y>206) && (y<235)) // - clicked
        {
          if ((maxques-1)<1) return true;
          maxques--;
          maxquestions--;
          repaint();
          return(true);
        }

      if ((intro) && (x>166) && (x<209) && (y>174) && (y<202)) // + clicked (10s)
         {
           if((maxques+10)>maxques2) return true;
           maxques=maxques+10;
           maxquestions=maxquestions+10;
           repaint();
           return(true);
          }
      if ((intro) && (x>166) && (x<209) && (y>206) && (y<235)) // - clicked (10s)
         {
           if((maxques-10) <1) return true;
           maxques=maxques-10;
           maxquestions=maxquestions-10;
           repaint();
           return(true);
         }


      // check imagebox

      if((x>400) && (x<420) && (y>30) && (y<50) && (imagestringavail))
           {
             paintimg=true;
             repaint();
             return true;
            }

      // check the quit button
      
      if ((x>280) && (x<300) && (y>270) && (y<290))
        {
          qbutt=!qbutt;
          repaint();
        }
      // sound toggle

      if ((x>40) && (x<60) && (y>270) && (y<290))
        {
          soundtoggle=!soundtoggle;
          if (soundtoggle) msg2="NoSound";
          if (!soundtoggle) msg2 = " Sound ";
          repaint();
        }

      if ((x>50) && (x<500) && (y>100) && (y<120))
        {
          chk1=!chk1;
          chkboxclicked=true;
          repaint();
        }
      if ((x>50) && (x<500) && (y>130) && (y<150))
        {
          chk2=!chk2;
          chkboxclicked=true;
          repaint();
        }
      if ((x>50) && (x<500) && (y>160) && (y<180))
        {
          chk3=!chk3;
          chkboxclicked=true;
          repaint();
        }
      if ((x>50) && (x<500) && (y>190) && (y<220))
        {
          chk4=!chk4;
          chkboxclicked=true;
          repaint();
        }
      if ((x>50) && (x<500) && (y>220) && (y<240))
        {
          chk5=!chk5;
          chkboxclicked=true;
          repaint();
        }

// 'enter' button clicked

      if ((intro) && (x>215) && (x<275) && (y>270) && (y<290))
          {
            intro=false;
            repaint();
            if(soundtoggle) hello.play();
            return true;
           }

      if ((x>180) && (x<240) && (y>270) && (y<290))
        {
        if(intro)
        {
          intro=false;
          repaint();
          if (soundtoggle) hello.play();
          return true;
         }
        if (!intro) enterclick();
        return true;
        }

// 'skip' button clicked
      if ((x>10)&& (x<30) && (y>270) && (y<290))
        {
          imagestringavail=false;
          resetvals();
          retries=0;
          re=false;
          return true;
        }

// 'reset' button clicked

      if ((x>280) && (x<300) && (y>270) && (y<290))
        {
          if (soundtoggle) beep.play();
          intro=true;
          maxques3=0;
          endtest=false;
          chk1 = false;
          chk2 = false;
          chk3 = false;
          chk4 = false;
          chk5 = false;
          xx=1;
          imagestringavail=false;
          retries=0;
          re=false;
          currentquestion=1;
          score=0;
          xx=1;
          chk1 = false;
          chk2 = false;
          chk3 = false;
          chk4 = false;
          chk5 = false;

          q1=" ";
          q2=" ";
          q3=" ";
          q4=" ";
          q5=" ";

          line1=" ";
          line2=" ";
          line3=" ";
          line4=" ";

          setup(maxques2);
          setquestions();
          resetclicked=true;
          repaint();
        }

     return true;
    }

  public boolean keyDown(Event e, int x)
    {
    //  if (x==13)
        {
          if (intro) return true;
          enterclick();
        }
      return false;
    }

  public void enterclick()
   {
          if(paintimg)
            {
              paintimg=false;
              repaint();
              return;
            }
          if(paintmsg)
            {
              paintmsg=!paintmsg;
              repaint();
              return;
            }

          if (chkanswer())
            {
             paintmsg=true;
             if (soundtoggle) beep.play();
             msg="Correct! Press Enter";
             if (!re)
               {
                  score++;
               }
             else
               {
                 msg="Correct, but no credit for retry";
               }
             imagestringavail=false;
             re=false;
             retries=0;
             resetvals();
             return;
            }

             re=true;
             paintmsg=true;
             if (soundtoggle) gong.play();
             msg="Sorry, Wrong Answer.  Try Once More";
             retries=retries+1;
             if (retries > maxretries)
               {
                msg="The correct answer is: " + answer;
               
               }
             repaint();
             return;


   }

  public void resetvals()   // does what you think .. resets values of
                            // game so you can restart
   {
          chk1 = false;
          chk2 = false;
          chk3 = false;
          chk4 = false;
          chk5 = false;

          q1=" ";
          q2=" ";
          q3=" ";
          q4=" ";
          q5=" ";

          line1=" ";
          line2=" ";
          line3=" ";
          line4=" ";

          currentquestion++;
          setquestions();
          repaint();
    }

  public void writescore(Graphics g)
    {
      g.setColor(Color.black);
      g.setFont(tr14b);
      g.drawString("Score " + Integer.toString(score),10,15);
    }

  public void settitle(Graphics g)
    {
     g.setColor(Color.red);
     g.setFont(tr14b);
     while (caption.length()<20)
       {
         caption=" " + caption + " ";
       }
     g.drawString(caption,190,15);
     g.setFont(tr10);
     g.setColor(Color.lightGray);
     g.drawString(msg3,370,15);
     g.setColor(Color.lightGray);
     g.drawLine(50,25,450,25);
     g.drawLine(50,24,450,24);
     g.drawLine(50,23,450,23);
     g.setColor(Color.black);
    }

   public void setquestions()
     {
       int yy=0;
       int zz=1;
       int ww=0;
       xx=1;

       yy=returnint();
     //  System.out.println("yy="+yy);
      if (debug)
        {
        System.out.println(yy);
        }
       if(yy==0)
         {
           currentquestion--;

           line1="Test End - Score = " + Integer.toString(score) + " out of a possible " + Double.toString(maxquestions);
           line3="That's " + Double.toString((score/maxquestions)*100.0) + " percent";
           repaint();
           // test end
           endtest=true;
           // writescore(); // write score to cgi script on server
           return;
         }


       while (yy!=zz)
         {
           if(questions[xx].charAt(0)=='*')
             {
               zz++;
             }
          xx++;
         }

       //if(yy>1)xx--;      //modified 12Apr97
       while (questions[xx].charAt(0) != '*') xx++; //modified 12Apr97
       while (questions[xx] != "eof")
        {
          checkforimg();
          while (questions[xx].charAt(0) != '!')
            {
              if (questions[xx].charAt(0) == '*')
                {
                  xx++;
                }
              checkforimg();
              if (questions[xx].charAt(0) != '!')
                {
                  line1 = questions[xx];
                  xx++;
                }
              checkforimg();
              if (questions[xx].charAt(0) != '!')
                {
                  line2 = questions[xx];
                  xx++;
                }
              checkforimg();
              if (questions[xx].charAt(0) != '!')
                {
                  line3 = questions[xx];
                  xx++;
                }
              checkforimg();
              if (questions[xx].charAt(0) != '!')
                {
                  line4 = questions[xx];
                  xx++;
                }
              checkforimg();
              if (questions[xx].charAt(0) == '!')
                {
                  break;
                }
              xx++;
            }

          xx++;
          totalquestions=0;

          if (questions[xx].charAt(0) != '+')
            {
             q1=questions[xx];
             totalquestions++;
             xx++;
            }
          if (questions[xx].charAt(0) != '+')
            {
             q2=questions[xx];
             totalquestions++;
             xx++;
            }
          if (questions[xx].charAt(0) != '+')
            {
             q3=questions[xx];
             totalquestions++;
             xx++;
            }
          if (questions[xx].charAt(0) != '+')
            {
             q4=questions[xx];
             totalquestions++;
             xx++;
            }
          if (questions[xx].charAt(0) != '+')
            {
             q5=questions[xx];
             totalquestions++;
             xx++;
            }
          answer=" ";
          answer=(questions[xx].substring(1,questions[xx].length()));
          xx++;
          return;

         }
        
      }

   public void checkforimg()   // if image specified in question, say so
     {
       if (questions[xx].charAt(0)=='^')
         {
           xx++;
           imagestring=questions[xx];
           imagestringavail=true;
           xx++;
         }
     }

   public void intropaint(Graphics g)
    {
        // a number box with wiper controls

        int x;
        int y;

        x=150; // start of x pos of number box
        y=140; // start of y pos of number box

        g.drawImage(logo1,1,1,this);

        g.drawImage(jbutt1,x,y,this);
        g.setFont(tr24b);
        g.drawString("Welcome To The JAVA Quiz Shell",80,90);
        g.setFont(tr14b);
        g.drawString("There are " + Integer.toString(maxques2)+" possible questions.",150,120);
        g.drawString("Increase/decrease/keep the number and click START.",95,140);
        g.setFont(tr36b);
        if(maxques>99)
         {
          g.drawString(Integer.toString(maxques),x+70,y+77);
         }
         else
         {
          g.drawString(Integer.toString(maxques),x+80,y+77);
         }
        g.setColor(Color.lightGray);
        g.setFont(tr10b);
        g.fill3DRect(215,270,60,20,true);
        g.setColor(Color.black);
        g.drawString("START",230,299);
       
    }


  public void setup(int max)
    {
      int x;
      int y;

      cons=-1;

      for (x=0;x<(2000);x++)
        {
         dummy[x] = 0;
         deal[x] = 0;
        }

      // deal the cards - take max questions and shuffle them around
      // so they never show up in the same order.

      x=0;
      while (x < max)
        {
           y=rnd1.nextInt() % max;
           while(y<0)
             {
               y=rnd1.nextInt() % max;
             }

           y=y+1;

           if (dummy[y] != 1)
             {
               dummy[y]=1;
               deal[x]=y;
               x=x+1;
             }
         }
    }

   public int returnint()
     {
      cons++;
      if((deal[cons]==0) && (cons<1)) cons--;
      maxques3++;
      if (maxques3>maxques) return(deal[999]);
      return deal[cons];
     }

   public void writescore()  // to cgi script on server
   {
        try {

            String host = "academic.bellevue.edu/~cisg1/writescore.cgi?"+Integer.toString(score)+"+"+Integer.toString(maxques)+"+"+CGIcaption;
            URL jshell = new URL("http://"+host);
            //System.out.println("Opening connection");
            URLConnection jshellConnection = jshell.openConnection();
            //System.out.println("Connection Open - now getting data");
            DataInputStream dis = new DataInputStream(jshellConnection.getInputStream());
            String inputLine;
 
            while ((inputLine = dis.readLine()) != null);//clean off the input
                                                         //buffer (System prints
                                                         //are debug code)
           //{                                             
           //     System.out.println(inputLine);      
           // }                                      
            dis.close();
        } catch (MalformedURLException me) {
            System.out.println("MalformedURLException: " + me);
        } catch (IOException ioe) {
            System.out.println("IOException: " + ioe);
        }
    }
   public void setuptext()
   {
     questions[1] = "*";
     questions[2] = "The two basic types of Directory tree organization are:";
     questions[3] = "!";
     questions[4] = "locational and divisional";
     questions[5] = "locational and functional";
     questions[6] = "organization and organization unit";
     questions[7] = "centralized and decentralized";
     questions[8] = "+2";
     questions[9] = "*";
     questions[10] = "A network consultant is responsible for:";
     questions[11] = "!";
     questions[12] = "a single network";
     questions[13] = "a branch of a network";
     questions[14] = "networks belonging to several clients";
     questions[15] = "designing networks only";
     questions[16] = "+3";
     questions[17] = "*";
     questions[18] = "A standards document should NOT include:";
     questions[19] = "!";
     questions[20] = "naming standards for user objects";
     questions[21] = "number of users on the network";
     questions[22] = "properties to be used";
     questions[23] = "formats for property values";
     questions[24] = "+2";
     questions[25] = "*";
     questions[26] = "Putting an alias object under the Organization object for";
     questions[27] = "mobile users is a good idea if:";
     questions[28] = "!";
     questions[29] = "you have 20 or fewer users";
     questions[30] = "you have 20 or more users";
     questions[31] = "you have a large group that always goes to the same place";
     questions[32] = "you have a standardized file structure";
     questions[33] = "+1";
     questions[34] = "*";
     questions[35] = "If you have a large number of mobile users that go to the";
     questions[36] = "same place, you should:";
     questions[37] = "!";
     questions[38] = "place an alias under the organization object";
     questions[39] = "modify the user login script";
     questions[40] = "create Map objects";
     questions[41] = "place a R/W replica at the site";
     questions[42] = "+4";
     questions[43] = "*";
     questions[44] = "If you have single mobile user that goes to several sites, what";
     questions[45] = "would be the best way to allow them quick access?";
     questions[46] = "!";
     questions[47] = "create a custom login script with <NW-SITE> statements";
     questions[48] = "create a profile object";
     questions[49] = "create a directory map object";
     questions[50] = "create an alias object";
     questions[51] = "+1";
     questions[52] = "*";
     questions[53] = "Which type of username is not efficient for large networks:";
     questions[54] = "!";
     questions[55] = "first name, last name";
     questions[56] = "first initial, last name";
     questions[57] = "first name";
     questions[58] = "last name, first initial";
     questions[59] = "+3";
     questions[60] = "*";
     questions[61] = "Click on the graphic button and choose the BEST";
     questions[62] = "answer from below:";
     questions[63] = "^";
     questions[64] = "di5322.gif";
     questions[65] = "!";
     questions[66] = "Put another R/W replica in partition 1";
     questions[67] = "Put a Master replica in partition 1";
     questions[68] = "Put another R/W replica in partition 2";
     questions[69] = "Replace a R/W in partition 1";
     questions[70] = "Replace the Master replica in partition 2";
     questions[71] = "+2";
     questions[72] = "*";
     questions[73] = "A directory tree with a single administrator would be:";
     questions[74] = "!";
     questions[75] = "relatively deep";
     questions[76] = "wide and deep";
     questions[77] = "narrow at the top and deep";
     questions[78] = "relatively flat";
     questions[79] = "+4";
     questions[80] = "*";
     questions[81] = "The practical organization for a multiple location network is:";
     questions[82] = "!";
     questions[83] = "functional";
     questions[84] = "divisional";
     questions[85] = "correctional";
     questions[86] = "locational";
     questions[87] = "+4";
     questions[88] = "*";
     questions[89] = "An object that is seldom used in a Directory tree is:";
     questions[90] = "!";
     questions[91] = "organizational unit";
     questions[92] = "organization";
     questions[93] = "country";
     questions[94] = "user";
     questions[95] = "+3";
     questions[96] = "*";
     questions[97] = "The advantages of the locational organization do NOT include:";
     questions[98] = "!";
     questions[99] = "ease of partitioning";
     questions[100] = "easy centralized administration";
     questions[101] = "minimizing WAN traffic";
     questions[102] = "matching network topology";
     questions[103] = "+2";
     questions[104] = "*";
     questions[105] = "XYZ corporation has the WAN shown in the graphic (press the graphic";
     questions[106] = "button). Assume Bora Bora has one replica (its master). Pick One:";
     questions[107] = "^";
     questions[108] = "di5324.gif";
     questions[109] = "!";
     questions[110] = "Move a R/W from Bora Bora to Fiji";
     questions[111] = "Move a Master from Fiji to Centerville";
     questions[112] = "Move a R/W from Bora Bora to Centerville";
     questions[113] = "Move a R/W from Centerville to each location";
     questions[114] = "Move a Subordinate from Bora Bora";
     questions[115] = "+3";
     questions[116] = "*";
     questions[117] = "Which of the following is NOT a benefit of effective NDS design:";
     questions[118] = "!";
     questions[119] = "fault tolerance";
     questions[120] = "simplified installation";
     questions[121] = "improved security";
     questions[122] = "ease of access";
     questions[123] = "+2";
     questions[124] = "*";
     questions[125] = "The divisional organization";
     questions[126] = "!";
     questions[127] = "is rarely used";
     questions[128] = "divides the company into divisions or departments";
     questions[129] = "cannot be combined with other methods";
     questions[130] = "all of the above";
     questions[131] = "+4";
     questions[132] = "*";
     questions[133] = "NDS is usually implemented";
     questions[134] = "!";
     questions[135] = "for only the departments that need it";
     questions[136] = "for the entire organization at once";
     questions[137] = "by department or division";
     questions[138] = "one user at a time";
     questions[139] = "+3";
     questions[140] = "*";
     questions[141] = "Click on the graphic and compare Exhibit A with Exhibit B";
     questions[142] = "(two answers)";
     questions[143] = "^";
     questions[144] = "di5325.gif";
     questions[145] = "!";
     questions[146] = "Locational Vs Functional";
     questions[147] = "Functional Vs Locational";
     questions[148] = "Across a WAN Vs local directory updates";
     questions[149] = "Preferred Vs Not advisable";
     questions[150] = "+1,4";
     questions[151] = "*";
     questions[152] = "Which of the following names are INCORRECT";
     questions[153] = "(two answers)";
     questions[154] = "!";
     questions[155] = "ff00ff00  (internal IPX)";
     questions[156] = "FF00FG00  (internal IPX)";
     questions[157] = "ff00fg11  (external network)";
     questions[158] = "C0FFEE42  (internal IPX)";
     questions[159] = "DCreagan  (user name with lower case)";
     questions[160] = "+2,3";
     questions[161] = "*";
     questions[162] = "Which of the following are true about NAMING standards";
     questions[163] = "(3 answers)";
     questions[164] = "!";
     questions[165] = "Lower case can be specified in SOME cases";
     questions[166] = "Lower case is not appropriate for naming standards";
     questions[167] = "Hexidecimal numbers cannot be case sensitive";
     questions[168] = "Internal IPX numbers must be unique";
     questions[169] = "+1,3,4";
     questions[170] = "*";
     questions[171] = "You want to save space on your client workstations. You will";
     questions[172] = "not be using SMS or Personal Netware. Which VLMS do you exclude:";
     questions[173] = "(2 ans)";
     questions[174] = "!";
     questions[175] = "SMS";
     questions[176] = "TSASMS";
     questions[177] = "PEER";
     questions[178] = "PNW";
     questions[179] = "RSA";
     questions[180] = "+2,4";
     questions[181] = "*";
     questions[182] = "Time provider groups cannot contain:";
     questions[183] = "!";
     questions[184] = "reference time servers";
     questions[185] = "primary time servers";
     questions[186] = "single reference time servers";
     questions[187] = "secondary time servers";
     questions[188] = "+3";
     questions[189] = "*";
     questions[190] = "Which client software is most quickly upgraded:";
     questions[191] = "!";
     questions[192] = "An older version of DOS requester";
     questions[193] = "A Netware shell with ODI drivers";
     questions[194] = "IPX and NETX";
     questions[195] = "The OS/2 requester";
     questions[196] = "+1";
     questions[197] = "*";
     questions[198] = "To develop a migration strategy, you should:";
     questions[199] = "!";
     questions[200] = "Create workstation strategy";
     questions[201] = "Create server strategy";
     questions[202] = "Create application strategy";
     questions[203] = "Set up a lab";
     questions[204] = "+1,2,3,4";
     questions[205] = "*";
     questions[206] = "The VLM required for NDS access is:";
     questions[207] = "!";
     questions[208] = "NW4.VLM";
     questions[209] = "BIND.VLM";
     questions[210] = "NDS.VLM";
     questions[211] = "NDS41.VLM";
     questions[212] = "+3";
     questions[213] = "*";
     questions[214] = "Considerations when upgrading a workstation do NOT include:";
     questions[215] = "!";
     questions[216] = "Bindery services";
     questions[217] = "Backups";
     questions[218] = "Electrical hookups";
     questions[219] = "Security";
     questions[220] = "+3";
     questions[221] = "*";
     questions[222] = "Which is NOT a reason to create additional partitions?";
     questions[223] = "!";
     questions[224] = "allow further subdivison of Directory";
     questions[225] = "make resources easily accessible";
     questions[226] = "minimize network traffic";
     questions[227] = "provide redundancy for login authentication";
     questions[228] = "+1";
     questions[229] = "*";
     questions[230] = "When you want to configue the client install program:";
     questions[231] = "!";
     questions[232] = "use install.cfg";
     questions[233] = "use net.cfg";
     questions[234] = "use autoexec.bat";
     questions[235] = "use config.sys";
     questions[236] = "+1";
     questions[237] = "*";
     questions[238] = "What client software do you need to include for workstation backup?";
     questions[239] = "!";
     questions[240] = "RSA.VLM";
     questions[241] = "WSBU.VLM";
     questions[242] = "TSASMS.COM";
     questions[243] = "NMR.VLM";
     questions[244] = "+3";
     questions[245] = "*";
     questions[246] = "Which is not a disadvantage of increasing partitions?";
     questions[247] = "!";
     questions[248] = "Network traffic can be increased";
     questions[249] = "subordinate references can create problems";
     questions[250] = "time synchronization will take longer";
     questions[251] = "administration can take longer";
     questions[252] = "+3";
     questions[253] = "*";
     questions[254] = "A partition should span";
     questions[255] = "!";
     questions[256] = "single location";
     questions[257] = "any number of locations";
     questions[258] = "nearby locations only";
     questions[259] = "at least three locations";
     questions[260] = "+1";
     questions[261] = "*";
     questions[262] = "Which is NOT a benefit of replications?";
     questions[263] = "!";
     questions[264] = "faster network access";
     questions[265] = "fault tolerance for NDS data";
     questions[266] = "fault tolerence for data files";
     questions[267] = "easy administration";
     questions[268] = "+3";
     questions[269] = "*";
     questions[270] = "The best object to use to assign an administrator is:";
     questions[271] = "!";
     questions[272] = "user";
     questions[273] = "group";
     questions[274] = "OU";
     questions[275] = "OR";
     questions[276] = "+4";
     questions[277] = "*";
     questions[278] = "Which operating systems can be NDS clients";
     questions[279] = "!";
     questions[280] = "DOS";
     questions[281] = "UNIX";
     questions[282] = "MacIntosh";
     questions[283] = "OS/2";
     questions[284] = "+1,3,4";
     questions[285] = "*";
     questions[286] = "Which component is the most important in NW 4.1 besides NDS:";
     questions[287] = "!";
     questions[288] = "bindery services";
     questions[289] = "file system";
     questions[290] = "TCP/IP";
     questions[291] = "mobile use";
     questions[292] = "+2";
     questions[293] = "*";
     questions[294] = "To minimize WAN traffic, applications:";
     questions[295] = "!";
     questions[296] = "should be installed on one server";
     questions[297] = "should be installed on every server";
     questions[298] = "should be installed on local PCs";
     questions[299] = "should be installed on one server per location";
     questions[300] = "+4";
     questions[301] = "*";
     questions[302] = "Which object(s) should you avoid assigning rights?";
     questions[303] = "!";
     questions[304] = "[Root], Users";
     questions[305] = "groups";
     questions[306] = "organizational roles";
     questions[307] = "profiles";
     questions[308] = "+1";
     questions[309] = "*";
     questions[310] = "The object best used for assigning backups is:";
     questions[311] = "!";
     questions[312] = "organization";
     questions[313] = "organizational unit";
     questions[314] = "organizational role";
     questions[315] = "group";
     questions[316] = "+3";
     questions[317] = "*";
     questions[318] = "Which is not a possible security configuration:";
     questions[319] = "!";
     questions[320] = "Central administrator only";
     questions[321] = "Central administrator and exclusive administrators";
     questions[322] = "Container administrators only";
     questions[323] = "File system administrators only";
     questions[324] = "+4";
     questions[325] = "*";
     questions[326] = "Which object can be used to assign the same rights";
     questions[327] = "to users in different containers:";
     questions[328] = "!";
     questions[329] = "Organization";
     questions[330] = "Organizational Unit";
     questions[331] = "Group";
     questions[332] = "Profile";
     questions[333] = "+3";
     questions[334] = "*";
     questions[335] = "Which client operating system does NOT support NDS:";
     questions[336] = "!";
     questions[337] = "DOS";
     questions[338] = "MacIntosh";
     questions[339] = "OS/2";
     questions[340] = "UNIX";
     questions[341] = "+4";
     questions[342] = "*";
     questions[343] = "Which client cannot use any version of Netware";
     questions[344] = "without installing additional software:";
     questions[345] = "!";
     questions[346] = "UNIX";
     questions[347] = "OS/2";
     questions[348] = "DOS";
     questions[349] = "MacIntosh";
     questions[350] = "+1";
     questions[351] = "*";
     questions[352] = "Which is NOT one of the four types of replicas";
     questions[353] = "!";
     questions[354] = "subordinate reference";
     questions[355] = "time provider";
     questions[356] = "read-only";
     questions[357] = "read/write";
     questions[358] = "+2";
     questions[359] = "*";
     questions[360] = "The synchronization process in Netware 4.1";
     questions[361] = "!";
     questions[362] = "ensures replicas have same information at all times";
     questions[363] = "ensures replicas have approx. the same info.";
     questions[364] = "keeps a consistent time on the network";
     questions[365] = "creates new replicas as needed";
     questions[366] = "+2";
     questions[367] = "*";
     questions[368] = "Which replicas are considered writable?";
     questions[369] = "!";
     questions[370] = "Master";
     questions[371] = "Read-Only";
     questions[372] = "Read/Write";
     questions[373] = "Subordinate Reference";
     questions[374] = "+1,3";
     questions[375] = "*";
     questions[376] = "Name resolution is also called:";
     questions[377] = "!";
     questions[378] = "time synchronization";
     questions[379] = "synchronization";
     questions[380] = "tree walking";
     questions[381] = "object nameing";
     questions[382] = "+3";
     questions[383] = "*";
     questions[384] = "Which implemenation is the FIRST implementation:";
     questions[385] = "!";
     questions[386] = "lab";
     questions[387] = "test";
     questions[388] = "pilot";
     questions[389] = "walk-through";
     questions[390] = "+3";
     questions[391] = "*";
     questions[392] = "There are four ways to identify Design and Implementation Procedures.";
     questions[393] = "What are they?";
     questions[394] = "!";
     questions[395] = "Linear, Spiral, Modified Circular, Structured";
     questions[396] = "Phase dependent, Incremental, Cumulative, Prototyping";
     questions[397] = "Linear, Modified Spiral, Incremental, Structured";
     questions[398] = "+3";
     questions[399] = "*";
     questions[400] = "The Systems Design Life Cycle has which of the following ";
     questions[401] = "developmental phases:";
     questions[402] = "!";
     questions[403] = "Analysis, Design, Implementation, Maintenance";
     questions[404] = "Analysis, Structure, Scope, Maintenance";
     questions[405] = "Structure, Content, Reasoning";
     questions[406] = "+1";
     questions[407] = "*";
     questions[408] = "Which of the following are steps in the design process:";
     questions[409] = "!";
     questions[410] = "Identify solutions, evaluate alternatives, design";
     questions[411] = "Prepare schedules, evaluate alternatives, implement";
     questions[412] = "Prepare schedules, test, implement";
     questions[413] = "+1";
     questions[414] = "*";
     questions[415] = "Implementation has which of the following steps:";
     questions[416] = "!";
     questions[417] = "Define milestones, test, pilot, implement";
     questions[418] = "Agree on charter, test, pilot, implement";
     questions[419] = "Test, pilot, implement";
     questions[420] = "+1";
     questions[421] = "*";
     questions[422] = "Click on the graphic button and select the best tree structure";
     questions[423] = "for the WAN from the options below:";
     questions[424] = "^";
     questions[425] = "di5323.gif";
     questions[426] = "!";
     questions[427] = "exhibit A";
     questions[428] = "exhibit B";
     questions[429] = "exhibit C";
     questions[430] = "exhibit D";
     questions[431] = "+1";
     questions[432] = "*";
     questions[433] = "Analysis and Specification has which of the following steps:";
     questions[434] = "!";
     questions[435] = "Recognize the business need, schedule, list members";
     questions[436] = "State the need, prepare schedules, identify solutions";
     questions[437] = "State the need, prepare schedules, implement a pilot";
     questions[438] = "+1";
     questions[439] = "*";
     questions[440] = "Which of the following should every phase include:";
     questions[441] = "!";
     questions[442] = "A chance for users to contribute";
     questions[443] = "A chance for management to stop the show";
     questions[444] = "A chance to redefine the scope";
     questions[445] = "A chance to train the project team";
     questions[446] = "+1,2";
     questions[447] = "*";
     questions[448] = "What are the four procedures of the design phase?";
     questions[449] = "!";
     questions[450] = "Create schedule, Replication, Time Sync, Accessibility";
     questions[451] = "Design tree, Replication, Time Sync, Accessibility";
     questions[452] = "Gather information, revise tree, Time Sync, Accessibility";
     questions[453] = "+2";
     questions[454] = "*";
     questions[455] = "Using stamp information, servers can provide useful time ";
     questions[456] = "stamps to:";
     questions[457] = "!";
     questions[458] = "NDS events";
     questions[459] = "Messaging apps";
     questions[460] = "File Systems";
     questions[461] = "User properties ";
     questions[462] = "+1,2,3";
     questions[463] = "*";
     questions[464] = "What are the reasons for determining a partition and replication";
     questions[465] = "strategy?";
     questions[466] = "!";
     questions[467] = "scalability";
     questions[468] = "fault tolerance";
     questions[469] = "accessibility";
     questions[470] = "project assessment";
     questions[471] = "+1,2,3";
     questions[472] = "*";
     questions[473] = "Why do we need an accessibility plan?";
     questions[474] = "!";
     questions[475] = "intuitive to administer";
     questions[476] = "easier to employ";
     questions[477] = "ensure authentication";
     questions[478] = "+1,2";
     questions[479] = "*";
     questions[480] = "In implemenation, who should get the first upgrade to 4.1?";
     questions[481] = "!";
     questions[482] = "Pilot department";
     questions[483] = "Management";
     questions[484] = "Finance department";
     questions[485] = "A department that can be offline for short periods";
     questions[486] = "+1";
     questions[487] = "*";
     questions[488] = "What are the steps to the project approach?";
     questions[489] = "!";
     questions[490] = "Organize the team";
     questions[491] = "Gather information";
     questions[492] = "Train the team";
     questions[493] = "Define the scope";
     questions[494] = "Create the design schedule";
     questions[495] = "+1,2,3,4";
     questions[496] = "*";
     questions[497] = "Organizing the project team includes which of the following:";
     questions[498] = "!";
     questions[499] = "Definition of roles";
     questions[500] = "Establishment of expectations";
     questions[501] = "Accomodation of concerns";
     questions[502] = "Elimination of possible alternatives";
     questions[503] = "+1,2,3";
     questions[504] = "*";
     questions[505] = "You have a large company separated by WAN links";
     questions[506] = "You should:";
     questions[507] = "!";
     questions[508] = "Create a single organizational object at the top";
     questions[509] = "Create OU for every division";
     questions[510] = "Create OU for each location";
     questions[511] = "Create OU for distinct business units and locations";
     questions[512] = "+1,4";
     questions[513] = "*";
     questions[514] = "The advantages of additional replicas include";
     questions[515] = "!";
     questions[516] = "fault tolerance";
     questions[517] = "authentication improvement";
     questions[518] = "better time synchronization";
     questions[519] = "navigation";
     questions[520] = "+1,2,4";
     questions[521] = "*";
     questions[522] = "If I install 20 servers into my netware partition,";
     questions[523] = "how many will have replicas?";
     questions[524] = "!";
     questions[525] = "2";
     questions[526] = "3";
     questions[527] = "5";
     questions[528] = "all but the last 3";
     questions[529] = "20";
     questions[530] = "+2";
     questions[531] = "*";
     questions[532] = "Click on the graphic button and choose the appropriate answer";
     questions[533] = "below:";
     questions[534] = "^";
     questions[535] = "di5321.gif";
     questions[536] = "!";
     questions[537] = "1";
     questions[538] = "2";
     questions[539] = "3";
     questions[540] = "4";
     questions[541] = "+2";
     questions[542] = "*";
     questions[543] = "If I merge 20 servers into my network,";
     questions[544] = "how many will have replicas?";
     questions[545] = "!";
     questions[546] = "2";
     questions[547] = "3";
     questions[548] = "4";
     questions[549] = "all but the last 3";
     questions[550] = "20";
     questions[551] = "+5";
     questions[552] = "*";
     questions[553] = "If I install 20 upgraded servers into my network,";
     questions[554] = "how many will have replicas?";
     questions[555] = "!";
     questions[556] = "2";
     questions[557] = "3";
     questions[558] = "4";
     questions[559] = "all but the last 3";
     questions[560] = "20";
     questions[561] = "+5";
     questions[562] = "*";
     questions[563] = "At what level of servers holding replicas in your organization";
     questions[564] = "should you consider custom partitioning?";
     questions[565] = "!";
     questions[566] = "20";
     questions[567] = "30";
     questions[568] = "15";
     questions[569] = "5";
     questions[570] = "+3";
     questions[571] = "*";
     questions[572] = "When should you consider configured time sources and set";
     questions[573] = "up a test lab?";
     questions[574] = "!";
     questions[575] = "20 servers";
     questions[576] = "30 servers";
     questions[577] = "15 servers";
     questions[578] = "5  servers";
     questions[579] = "+2";
     questions[580] = "*";
     questions[581] = "Use default partitioning when you have:";
     questions[582] = "!";
     questions[583] = "No WAN links";
     questions[584] = "15 or fewer servers holding replicas";
     questions[585] = "fewer than 7000 objects";
     questions[586] = "fewer than 5000 objects";
     questions[587] = "30 or fewer servers holding replicas";
     questions[588] = "+1,2,4";
     questions[589] = "*";
     questions[590] = "When should you consider partitioning AND configured time ";
     questions[591] = "sources";
     questions[592] = "!";
     questions[593] = "Multiple sites in the same area";
     questions[594] = "Multiple sites connected by a wan";
     questions[595] = "Single sites with less than 10 servers";
     questions[596] = "Single sites with more than 10 servers";
     questions[597] = "+2";
     questions[598] = "*";
     questions[599] = "Upper levels should be :";
     questions[600] = "!";
     questions[601] = "Less likely to change";
     questions[602] = "Narrower";
     questions[603] = "Wider";
     questions[604] = "More flexible";
     questions[605] = "+1,2";
     questions[606] = "*";
     questions[607] = "To perform an effective design and implementation you need ";
     questions[608] = "to collect background information using the organization's";
     questions[609] = "documents - which include:";
     questions[610] = "!";
     questions[611] = "WAN and LAN layouts";
     questions[612] = "Office locations";
     questions[613] = "Company resources";
     questions[614] = "User profiles";
     questions[615] = "Expected throughput";
     questions[616] = "+1,2,3";
     questions[617] = "eof";
   }
}
