/*

 this code is copyright 1996 by Dan Creagan.                 
 You can get him at dcreagan@scholars.bellevue.edu          


As of  the 28 July version, this skeleton requires a CGI script file on
the host to process scores.  The script is manipulated in the
writescore method (the last one).  Study it to see how to change it
for your machine.  The web version has this method disabled, but you
can enable it by uncommenting the procedure call at line 739.

The script should look like this in GNU C for Linux
with CGI runnable anywhere:


#include <stdio.h>
#include <stdlib.h>
#include <string.h>


void main(int argc, char *argv[])
{

FILE *outfile;
char score[120];
char maxques[120];
char caption[120];
char filename[120];
int x,y;

if (argc<2)
  {
    printf("\nContent-type: text/plain \n\n");
    printf("Invalid number of arguments.(%d)\n",argc);
    exit(0);
   }

  strcpy(filename,"javascores.dat");
  strcpy(score,argv[1]);
  if (argc>2){strcpy(maxques,argv[2]);}
  if (argc>3){strcpy(caption,argv[3]);}
  outfile=fopen(filename,"at");
  if(!outfile)
  {
    printf("\nContent-type: text/plain \n\nCould not open the scorefile.\n");
    exit(0);
  }

  fprintf(outfile,"     %s ",score);
  if (argc>2) fprintf(outfile,"                 %s ",maxques);
  if (argc>3) fprintf(outfile,"           %s",caption);
  fprintf(outfile,"\n");  
  fclose(outfile);
  printf("Content-type: text/plain \n\n");
  printf("\nScore File Updated: score = %s\n",argv[1]);
}  
*/

import java.net.*;
import java.applet.*;
import java.awt.*;
import java.util.Date;
import java.util.Random;
import java.io.*;

//
//  The following class declaration gets modified by the javconvt.pl
//  program.  It gets updated to the name of the .txt file you feed
//  it.  The text file has the questions for the students/viewers.
//

public class skeleton extends Applet
{

     String msg3 = new String("by Dan Creagan, ver 41297");
                                                               
     Image img;
     Image jbutt1;
     Image logo1;

     Random rnd1 = new Random();
     int dummy[] = new int[2000];
     int deal[] = new int[2000];
     int cons=-1;

      int maxques =  72;
      double maxquestions =  72.0;
     int maxques2;
     int maxques3 = 0;

     String questions[] = new String[2000];
     String answer = new String(" ");
     String imagestring=new String("nwadmin.gif");
     String jbutt = new String("jbutt.gif");
     String logo = new String("bs4.gif");
     String caption = new String("JAVATEST");
     String CGIcaption = new String("JAVATEST");

     int debugx = 0;
     int debugy = 0;
     int score=0;
     int currentquestion = 1;
     int retries = 0;
     int totalquestions = 0;
     int maxretries =1;
     AudioClip beep;
     AudioClip hasta;
     AudioClip gong;
     AudioClip hello;
     AudioClip bkgrd;
     String title="JAVA Quiz Shell";
     boolean soundtoggle = true;
     boolean retry = false;
     boolean qbutt = false;
     boolean chk1 = false;
     boolean chk2 = false;
     boolean chk3 = false;
     boolean chk4 = false;
     boolean chk5 = false;
     boolean enter = false;
     boolean restart = false;
     boolean paintimg = false;
     boolean imagestringavail = false;
     boolean paintmsg = false;
     boolean re = false;
     boolean debug=false;
     boolean endtest=false;
     boolean intro=true;
     boolean resetclicked=false;
     boolean chkboxclicked=false;

     String line1 = new String(" ");
     String line2 = new String(" ");
     String line3 = new String(" ");
     String line4 = new String(" ");

     String q1 = new String(" ");
     String q2 = new String(" ");
     String q3 = new String(" ");
     String q4 = new String(" ");
     String q5 = new String(" ");

     String msg;
     String msg2= new String("NoSound");

     int xx=1;
     Font tr12 = new Font("TimesRoman", Font.PLAIN, 12);
     Font tr12b = new Font("TimesRoman", Font.BOLD, 12);
     Font tr14 = new Font("TimesRoman", Font.PLAIN, 14);
     Font tr14b = new Font("TimesRoman", Font.BOLD, 14);
     Font tr10 = new Font("TimesRoman", Font.PLAIN, 10);
     Font tr10b = new Font("TimesRoman", Font.BOLD, 10);
     Font tr24b = new Font("TimesRoman", Font.BOLD, 24);
     Font tr18b = new Font("TimesRoman", Font.BOLD, 18);
     Font tr36b = new Font("TimesRoman", Font.BOLD, 36);

  public void stop()
   {
    if (soundtoggle) hasta.play();
   }

  public void init()
   {

     caption=getParameter("caption");
     CGIcaption=caption;

     hello= getAudioClip(getCodeBase(),"hello2.au");
     beep = getAudioClip(getCodeBase(),"beep.au");
     hasta = getAudioClip(getCodeBase(),"hasta.au");
     gong = getAudioClip(getCodeBase(),"gong.au");
     beep.play();
     jbutt1=getImage(getCodeBase(),jbutt);

     logo1=getImage(getCodeBase(),logo);

     setup(maxques); // set up random number generator

     setBackground(Color.white);
     setuptext();
     setquestions();
     maxques2=maxques;
   }



  public void paint(Graphics g)
    {
      update(g);
    }
  public void update(Graphics g)
    {
     if (intro)
      {
       if(resetclicked)
         {
           g.setColor(Color.white);
           g.fillRect(0,0,500,400); // clear work area
           resetclicked=false;
         }
       settitle(g);
       intropaint(g);
       return;
      }
     // cls

     if(!chkboxclicked)
     {
       g.setColor(Color.white);
       g.fillRect(0,0,500,300);
     }
     if (paintimg)
       {

         img=getImage(getCodeBase(),imagestring);
         g.drawImage(img,1,1,this);
         g.setColor(Color.lightGray);
         g.setFont(tr10);
         g.fill3DRect(180,270,60,20,true);
         g.setColor(Color.black);
         g.drawString("Return",195,299);
         return;
       }

     if(paintmsg)
       {
         g.setColor(Color.red);
         g.setFont(tr24b);
         if (msg.length() > 28) g.setFont(tr14b);
         g.drawString(msg,150,150);
         g.setColor(Color.lightGray);
         g.setFont(tr10);
         g.fill3DRect(180,270,60,20,true);
         g.setColor(Color.black);
         g.drawString("Enter",199,299);
         return;
        }

     // title and credits
     settitle(g);
     // score
     writescore(g);
     // chkboxes
     writechkbox(g);
    
    }

  public void writechkbox(Graphics g)
    {
     g.setColor(Color.black);
     g.setFont(tr14);
     g.drawString(line1,50,50);
     g.drawString(line2,50,70);
     g.drawString(line3,50,90);
     g.drawString(line4,50,110);

     g.setFont(tr12b);

     g.drawString(q1,75,115);
     g.drawString(q2,75,145);
     g.drawString(q3,75,175);
     g.drawString(q4,75,205);
     g.drawString(q5,75,235);

     g.setColor(Color.lightGray);

     g.drawString(" " + Integer.toString(currentquestion) + " of " +  Double.toString(maxquestions),350,290); 

     if (imagestringavail)
       {
        g.setColor(Color.lightGray);
        g.fill3DRect(400,30,20,20,true);
        g.setColor(Color.black);
        g.setFont(tr10b);
        g.drawString("GraFik",395,60);
        g.setColor(Color.lightGray);
       }

     if((chk1)&&(totalquestions>0))
       {
         g.draw3DRect(50,100,20,20,true);
         g.setColor(Color.red);
         g.drawString("X",56,115);
         g.setColor(Color.lightGray);
       }
       else
         {
           if ((!endtest)&&(totalquestions>0)) g.fill3DRect(50,100,20,20,true);
         }
     if((chk2) && (totalquestions>1))
       {
         g.draw3DRect(50,130,20,20,true);
         g.setColor(Color.red);
         g.drawString("X",56,145);
         g.setColor(Color.lightGray);
       }
       else
         {
           if ((!endtest)&&(totalquestions>1)) g.fill3DRect(50,130,20,20,true);
         }
     if((chk3) && (totalquestions>2))
       {
         g.draw3DRect(50,160,20,20,true);
         g.setColor(Color.red);
         g.drawString("X",56,175);
         g.setColor(Color.lightGray);
       }
       else
         {
           if ((!endtest)&&(totalquestions>2)) g.fill3DRect(50,160,20,20,true);
         }
     if((chk4)&& (totalquestions>3))
       {
         g.draw3DRect(50,190,20,20,true);
         g.setColor(Color.red);
         g.drawString("X",56,205);
         g.setColor(Color.lightGray);
       }
       else
         {
           if((!endtest)&&(totalquestions>3)) g.fill3DRect(50,190,20,20,true);
         }
     if((chk5) && (totalquestions>4))
       {
         g.draw3DRect(50,220,20,20,true);
         g.setColor(Color.red);
         g.drawString("X",56,235);
         g.setColor(Color.lightGray);
       }
       else
         {
           if ((!endtest)&&(totalquestions>4)) g.fill3DRect(50,220,20,20,true);
         }
      if(enter)
       {
           g.draw3DRect(180,270,60,20,true);
       }
       else
         { 
           g.fill3DRect(180,270,60,20,true);
         }
       if(restart)
        {
          g.draw3DRect(280,270,20,20,true);
        }
        else
          {
            g.fill3DRect(280,270,20,20,true);
          }

     /*
     if (qbutt)
       {
         g.draw3DRect(280,270,20,20,true);
       }
     else
       {
         g.fill3DRect(280,270,20,20,true);
       }
     */
     // skip button

     g.fill3DRect(10,270,20,20,true);

     // sound toggle

     g.fill3DRect(40,270,20,20,true);


     g.setFont(tr10b);
     g.setColor(Color.black);
     g.drawString("Enter",199,299);
     g.drawString("Restart",276,299);
     g.drawString("Skip",10,299);
     g.drawString(msg2,34,299);


    }

     public boolean chkanswer()
       {

       //
       // called if a user has clicked enter and we now have to
       // determine if the answer given was correct.  We first
       // check to see if a box was checked and it wasn't in the answer list

        if ((chk1) && (answer.indexOf('1')<0))
          {
           return false;
          }
        if ((chk2) && (answer.indexOf('2')<0))
          {
           return false;
          }
        if ((chk3) && (answer.indexOf('3')<0))
          {
            return false;
          }
        if ((chk4) && (answer.indexOf('4')<0))
          {
            return false;
          }
        if ((chk5) && (answer.indexOf('5')<0))
          {
            return false;
          }
        // check to see if a box WASN'T checked and it WAS in answer list

        if ((!chk1) && (answer.indexOf('1')>-1))
          {
            return false;
          }
        if ((!chk2) && (answer.indexOf('2')>-1))
          {
            return false;
          }
        if ((!chk3) && (answer.indexOf('3')>-1))
          {
            return false;
          }
        if ((!chk4) && (answer.indexOf('4')>-1))
          {
            return false;
          }
        if ((!chk5) && (answer.indexOf('5')>-1))
          {
            return false;
          }
        return true;
       }



  public boolean mouseUp(Event evt, int x, int y)
    {
      chkboxclicked=false;
      //
      // variable 'intro' is true when the first screen is showing
      // if true, we look for mouse clicks that signify change of
      // total questions that user wants to see
      //

      if((intro)&& (x>285) && (x<329) && (y>174) && (y<202)) // + clicked
        {
         if ((maxques+1)>maxques2) return true;
         maxques++;
         maxquestions++;
         repaint();
         return(true);
        }
      if ((intro) && (x>285) && (x<329) && (y>206) && (y<235)) // - clicked
        {
          if ((maxques-1)<1) return true;
          maxques--;
          maxquestions--;
          repaint();
          return(true);
        }

      if ((intro) && (x>166) && (x<209) && (y>174) && (y<202)) // + clicked (10s)
         {
           if((maxques+10)>maxques2) return true;
           maxques=maxques+10;
           maxquestions=maxquestions+10;
           repaint();
           return(true);
          }
      if ((intro) && (x>166) && (x<209) && (y>206) && (y<235)) // - clicked (10s)
         {
           if((maxques-10) <1) return true;
           maxques=maxques-10;
           maxquestions=maxquestions-10;
           repaint();
           return(true);
         }


      // check imagebox

      if((x>400) && (x<420) && (y>30) && (y<50) && (imagestringavail))
           {
             paintimg=true;
             repaint();
             return true;
            }

      // check the quit button
      
      if ((x>280) && (x<300) && (y>270) && (y<290))
        {
          qbutt=!qbutt;
          repaint();
        }
      // sound toggle

      if ((x>40) && (x<60) && (y>270) && (y<290))
        {
          soundtoggle=!soundtoggle;
          if (soundtoggle) msg2="NoSound";
          if (!soundtoggle) msg2 = " Sound ";
          repaint();
        }

      if ((x>50) && (x<500) && (y>100) && (y<120))
        {
          chk1=!chk1;
          chkboxclicked=true;
          repaint();
        }
      if ((x>50) && (x<500) && (y>130) && (y<150))
        {
          chk2=!chk2;
          chkboxclicked=true;
          repaint();
        }
      if ((x>50) && (x<500) && (y>160) && (y<180))
        {
          chk3=!chk3;
          chkboxclicked=true;
          repaint();
        }
      if ((x>50) && (x<500) && (y>190) && (y<220))
        {
          chk4=!chk4;
          chkboxclicked=true;
          repaint();
        }
      if ((x>50) && (x<500) && (y>220) && (y<240))
        {
          chk5=!chk5;
          chkboxclicked=true;
          repaint();
        }

// 'enter' button clicked

      if ((intro) && (x>215) && (x<275) && (y>270) && (y<290))
          {
            intro=false;
            repaint();
            if(soundtoggle) hello.play();
            return true;
           }

      if ((x>180) && (x<240) && (y>270) && (y<290))
        {
        if(intro)
        {
          intro=false;
          repaint();
          if (soundtoggle) hello.play();
          return true;
         }
        if (!intro) enterclick();
        return true;
        }

// 'skip' button clicked
      if ((x>10)&& (x<30) && (y>270) && (y<290))
        {
          imagestringavail=false;
          resetvals();
          retries=0;
          re=false;
          return true;
        }

// 'reset' button clicked

      if ((x>280) && (x<300) && (y>270) && (y<290))
        {
          if (soundtoggle) beep.play();
          intro=true;
          maxques3=0;
          endtest=false;
          chk1 = false;
          chk2 = false;
          chk3 = false;
          chk4 = false;
          chk5 = false;
          xx=1;
          imagestringavail=false;
          retries=0;
          re=false;
          currentquestion=1;
          score=0;
          xx=1;
          chk1 = false;
          chk2 = false;
          chk3 = false;
          chk4 = false;
          chk5 = false;

          q1=" ";
          q2=" ";
          q3=" ";
          q4=" ";
          q5=" ";

          line1=" ";
          line2=" ";
          line3=" ";
          line4=" ";

          setup(maxques2);
          setquestions();
          resetclicked=true;
          repaint();
        }

     return true;
    }

  public boolean keyDown(Event e, int x)
    {
    //  if (x==13)
        {
          if (intro) return true;
          enterclick();
        }
      return false;
    }

  public void enterclick()
   {
          if(paintimg)
            {
              paintimg=false;
              repaint();
              return;
            }
          if(paintmsg)
            {
              paintmsg=!paintmsg;
              repaint();
              return;
            }

          if (chkanswer())
            {
             paintmsg=true;
             if (soundtoggle) beep.play();
             msg="Correct! Press Enter";
             if (!re)
               {
                  score++;
               }
             else
               {
                 msg="Correct, but no credit for retry";
               }
             imagestringavail=false;
             re=false;
             retries=0;
             resetvals();
             return;
            }

             re=true;
             paintmsg=true;
             if (soundtoggle) gong.play();
             msg="Sorry, Wrong Answer.  Try Once More";
             retries=retries+1;
             if (retries > maxretries)
               {
                msg="The correct answer is: " + answer;
               
               }
             repaint();
             return;


   }

  public void resetvals()   // does what you think .. resets values of
                            // game so you can restart
   {
          chk1 = false;
          chk2 = false;
          chk3 = false;
          chk4 = false;
          chk5 = false;

          q1=" ";
          q2=" ";
          q3=" ";
          q4=" ";
          q5=" ";

          line1=" ";
          line2=" ";
          line3=" ";
          line4=" ";

          currentquestion++;
          setquestions();
          repaint();
    }

  public void writescore(Graphics g)
    {
      g.setColor(Color.black);
      g.setFont(tr14b);
      g.drawString("Score " + Integer.toString(score),10,15);
    }

  public void settitle(Graphics g)
    {
     g.setColor(Color.red);
     g.setFont(tr14b);
     while (caption.length()<20)
       {
         caption=" " + caption + " ";
       }
     g.drawString(caption,190,15);
     g.setFont(tr10);
     g.setColor(Color.lightGray);
     g.drawString(msg3,370,15);
     g.setColor(Color.lightGray);
     g.drawLine(50,25,450,25);
     g.drawLine(50,24,450,24);
     g.drawLine(50,23,450,23);
     g.setColor(Color.black);
    }

   public void setquestions()
     {
       int yy=0;
       int zz=1;
       int ww=0;
       xx=1;

       yy=returnint();
     //  System.out.println("yy="+yy);
      if (debug)
        {
        System.out.println(yy);
        }
       if(yy==0)
         {
           currentquestion--;

           line1="Test End - Score = " + Integer.toString(score) + " out of a possible " + Double.toString(maxquestions);
           line3="That's " + Double.toString((score/maxquestions)*100.0) + " percent";
           repaint();
           // test end
           endtest=true;
           // writescore(); // write score to cgi script on server
           return;
         }


       while (yy!=zz)
         {
           if(questions[xx].charAt(0)=='*')
             {
               zz++;
             }
          xx++;
         }

       //if(yy>1)xx--;      //modified 12Apr97
       while (questions[xx].charAt(0) != '*') xx++; //modified 12Apr97
       while (questions[xx] != "eof")
        {
          checkforimg();
          while (questions[xx].charAt(0) != '!')
            {
              if (questions[xx].charAt(0) == '*')
                {
                  xx++;
                }
              checkforimg();
              if (questions[xx].charAt(0) != '!')
                {
                  line1 = questions[xx];
                  xx++;
                }
              checkforimg();
              if (questions[xx].charAt(0) != '!')
                {
                  line2 = questions[xx];
                  xx++;
                }
              checkforimg();
              if (questions[xx].charAt(0) != '!')
                {
                  line3 = questions[xx];
                  xx++;
                }
              checkforimg();
              if (questions[xx].charAt(0) != '!')
                {
                  line4 = questions[xx];
                  xx++;
                }
              checkforimg();
              if (questions[xx].charAt(0) == '!')
                {
                  break;
                }
              xx++;
            }

          xx++;
          totalquestions=0;

          if (questions[xx].charAt(0) != '+')
            {
             q1=questions[xx];
             totalquestions++;
             xx++;
            }
          if (questions[xx].charAt(0) != '+')
            {
             q2=questions[xx];
             totalquestions++;
             xx++;
            }
          if (questions[xx].charAt(0) != '+')
            {
             q3=questions[xx];
             totalquestions++;
             xx++;
            }
          if (questions[xx].charAt(0) != '+')
            {
             q4=questions[xx];
             totalquestions++;
             xx++;
            }
          if (questions[xx].charAt(0) != '+')
            {
             q5=questions[xx];
             totalquestions++;
             xx++;
            }
          answer=" ";
          answer=(questions[xx].substring(1,questions[xx].length()));
          xx++;
          return;

         }
        
      }

   public void checkforimg()   // if image specified in question, say so
     {
       if (questions[xx].charAt(0)=='^')
         {
           xx++;
           imagestring=questions[xx];
           imagestringavail=true;
           xx++;
         }
     }

   public void intropaint(Graphics g)
    {
        // a number box with wiper controls

        int x;
        int y;

        x=150; // start of x pos of number box
        y=140; // start of y pos of number box

        g.drawImage(logo1,1,1,this);

        g.drawImage(jbutt1,x,y,this);
        g.setFont(tr24b);
        g.drawString("Welcome To The JAVA Quiz Shell",80,90);
        g.setFont(tr14b);
        g.drawString("There are " + Integer.toString(maxques2)+" possible questions.",150,120);
        g.drawString("Increase/decrease/keep the number and click START.",95,140);
        g.setFont(tr36b);
        if(maxques>99)
         {
          g.drawString(Integer.toString(maxques),x+70,y+77);
         }
         else
         {
          g.drawString(Integer.toString(maxques),x+80,y+77);
         }
        g.setColor(Color.lightGray);
        g.setFont(tr10b);
        g.fill3DRect(215,270,60,20,true);
        g.setColor(Color.black);
        g.drawString("START",230,299);
       
    }


  public void setup(int max)
    {
      int x;
      int y;

      cons=-1;

      for (x=0;x<(2000);x++)
        {
         dummy[x] = 0;
         deal[x] = 0;
        }

      // deal the cards - take max questions and shuffle them around
      // so they never show up in the same order.

      x=0;
      while (x < max)
        {
           y=rnd1.nextInt() % max;
           while(y<0)
             {
               y=rnd1.nextInt() % max;
             }

           y=y+1;

           if (dummy[y] != 1)
             {
               dummy[y]=1;
               deal[x]=y;
               x=x+1;
             }
         }
    }

   public int returnint()
     {
      cons++;
      if((deal[cons]==0) && (cons<1)) cons--;
      maxques3++;
      if (maxques3>maxques) return(deal[999]);
      return deal[cons];
     }

   public void writescore()  // to cgi script on server
   {
        try {

            String host = "academic.bellevue.edu/~cisg1/writescore.cgi?"+Integer.toString(score)+"+"+Integer.toString(maxques)+"+"+CGIcaption;
            URL jshell = new URL("http://"+host);
            //System.out.println("Opening connection");
            URLConnection jshellConnection = jshell.openConnection();
            //System.out.println("Connection Open - now getting data");
            DataInputStream dis = new DataInputStream(jshellConnection.getInputStream());
            String inputLine;
 
            while ((inputLine = dis.readLine()) != null);//clean off the input
                                                         //buffer (System prints
                                                         //are debug code)
           //{                                             
           //     System.out.println(inputLine);      
           // }                                      
            dis.close();
        } catch (MalformedURLException me) {
            System.out.println("MalformedURLException: " + me);
        } catch (IOException ioe) {
            System.out.println("IOException: " + ioe);
        }
    }
